import os
from pathlib import Path
from typing import List, Optional

from pydantic_settings import BaseSettings

class Settings(BaseSettings):
    # Base settings
    PROJECT_NAME: str = "Task Manager API"
    API_V1_STR: str = "/api/v1"
    
    # Database settings
    DB_DIR: Path = Path("/app/storage/db")
    
    class Config:
        case_sensitive = True
        env_file = ".env"

settings = Settings()

# Ensure DB directory exists
settings.DB_DIR.mkdir(parents=True, exist_ok=True)